﻿<template>
    <Suspense>
        <ShowMovie v-if="movie" :movie="movie"></ShowMovie>
        <section v-else class="error-show-movie">
            <h1>{{ t('pages.showMovie.error') }}</h1>
            <p>{{errorMessage}}</p>
            <button class="btn"><RouterLink :to="t('routes.home.path')" class="navbar__navlink">{{ t('pages.showMovie.backHomeButton') }}</RouterLink></button>
        </section>
        <template #fallback>
            <Loader />
        </template>
    </Suspense>
</template>

<script lang="ts" setup>
    import Loader from "@/components/layout/Loader.vue";
    import ShowMovie from "@/components/movies/ShowMovie.vue";
    import { useI18n } from "vue3-i18n";
    import { useMovieService, useMemberService } from "@/inversify.config";
    import { useMemberStore } from "@/stores/memberStore";
    import { Movie } from "@/types/entities/movie";
    import { selectRandomMovie, hasMemberSeenMovie } from "@/utils/movieUtils";

    const { t } = useI18n();
    const movieService = useMovieService();
    const memberService = useMemberService();
    const memberStore = useMemberStore();

    let movie: Movie | undefined;
    let errorMessage: string;

    const movies = await movieService.getRandomMovie();

    if (movies.movies) {

        if (memberStore.member.email) {
            const member = await memberService.getMemberWithId(memberStore.member.id)
            let movieGuess: Movie

            do {
                movieGuess = selectRandomMovie(movies);
                movies.movies = movies.movies.filter(movie => movie.title !== movieGuess.title);
            } while (hasMemberSeenMovie(member, movieGuess) && movies.movies.length > 0);

            if (movies.movies.length > 0)
                movie = movieGuess;
            else
                errorMessage = t('validation.movie.allSeen');
        }
        else {
            movie = selectRandomMovie(movies);
        }
    }
    else 
        errorMessage = t('validation.movie.noMovie');

</script>